;;;
;; gbm editing utility functions
;;;

;;; INSTALL - $BF~$lJ}$J$N$@(B
;;
;;	$B6&DL(B
;;	
;;	(autoload 'gbm-edit-mode "gbmedit" "Book File Editing Mode" t)
;;	(autoload 'gbm-gbreply "gbmedit" "Reply with gbreply" t)
;;	(autoload 'gbm-edit-mail-file "gbmedit" "Edit mail as book file" t)
;;	(setq auto-mode-alist
;;	      (cons (cons "/[12][0-9][0-9][0-9][0-9][0-9][0-9][0-9]-.*@.*"
;;			  'gbm-edit-mode)
;;		    auto-mode-alist))
;;	(setq gbm-gbreply-address "yuuji-ohenji@gentei.org") ;gbreply$B5/F0MQ(B
;;	(setq gbm-edit-books-dir-list ;book$B%U%!%$%k$N$"$k%G%#%l%/%H%j$rNs5s(B
;;	     '("~/public_html/gb/books" "~/http/gb/books" "~/www/gb/books"))
;;	
;;	$B$G(B mew $B$r;H$C$F$$$k>l9g$O$3$&!"(B
;;	
;;	(add-hook 'mew-draft-mode-hook 'gbm-gbreply)
;;	(add-hook 'mew-init-hook
;;	          '(lambda ()
;;		     (define-key mew-summary-mode-map "\M-\C-m"
;;		       'gbm-edit-mail-file)))
;;
;;	mh-e$B$N$R$H$OE,Ev$K(Bhook$BJQ?t$rJQ$($F@_Dj$7$F$/$@$A$c$$!#(B

(defvar gbm-edit-books-dir-list
  '("~/public_html/gb/books" "~/http/gb/books" "~/www/gb/books"))
(defvar gbm-gbreply-remove-cc-p t)

;;; [Part I] Direct editing mode

(defun gbm-edit-mail-file ()
  (interactive)
  (save-excursion
    (beginning-of-line)
    (skip-chars-forward " ")
    (let ((n (mew-summary-message-number))
	  (folder (substring (buffer-name) 1))
	  bookdir (bl gbm-edit-books-dir-list)
	  (rest (buffer-substring (point) (progn (end-of-line) (point)))))
      (while bl
	(if (file-directory-p (car bl))
	    (setq bookdir (car bl)
		  bl nil))
	(setq bl (cdr bl)))
      (or bookdir (setq bookdir "/tmp"))
      (find-file-other-window
       (cond
	((string-match "Guest Book" rest)
	 (save-window-excursion
	   (select-window (next-window))
	   (save-excursion
	     (goto-char (point-min))
	     (re-search-forward "file=\\(.*\\)")
	     (expand-file-name
	      (buffer-substring (match-beginning 1) (match-end 1))
	      bookdir))))
	(t ;(string-match "darts" rest)
	 (concat "~/Mail/" folder "/" n))))
      (cond
       ((string-match "/Mail/ir/" buffer-file-name)
	(goto-char (point-min))
	(re-search-forward "^Subject:\\s *" nil t))
       (t
	(re-search-forward "^$" (1- (point-max)) t)
	(set-window-start nil (point))
	(goto-char (point-max))
	(text-mode)
	(auto-fill-mode 0))))))

(defun gbm-edit-mode ()
  "Major mode for editing gbm's book files"
  (interactive)
  (text-mode)
  (auto-fill-mode 0)
  (setq major-mode 'gbm-edit-mode mode-name "gbm")
  (if (= (buffer-size) 0)
      (let ((mew-cite-prefix "") mew-cite-hook (cb (current-buffer)) s)
	(cond
	 ((fboundp 'mew-draft-cite)
	  (save-excursion (mew-draft-cite nil t)))
	 (t
	  (require 'xcite)
	  (save-window-excursion
	    (xcite-goto-article-window)
	    (save-excursion
	      (goto-char (point-min))
	      (re-search-forward "^$")
	      (re-search-forward "^\\S ")
	      (setq s (buffer-substring (match-beginning 0) (point-max)))
	      (set-buffer cb)
	      (insert-after-markers s)))))
	(goto-char (point-min))
	(delete-region
	 (point)
	 (progn (re-search-forward "^homepage=" nil) (match-end 0)))
	(forward-line 1)
	(delete-region (point)
		       (progn (looking-at "nickname=") (match-end 0)))
	(forward-line 1)
	(if nil ;(looking-at "theme=")
	    (progn
	      (delete-region (point) (match-end 0))
	      (end-of-line)))
	(delete-region (point)
		       (progn (re-search-forward
			       "^message.*follows\\.\\.\\.$" nil 1)
			      (1+ (match-end 0))))
	(if (re-search-forward "\\.\nquit$" nil 1)
	    (delete-region (match-beginning 0) (match-end 0)))
	(insert ?\n)
	(delete-blank-lines)
	(or (save-excursion
	      (re-search-backward "^_EOM_$" nil t))
	    (insert "_EOM_\n"))
	(message "Setting up book file."))))

;;; [Part II] Reply with gbreply (c) masao
(defun gbm-gbreply ()
  (save-excursion
    (goto-char (point-min))
    (require 'xcite)
    (and (string= (xcite-get-field "Subject:") "Guest Book Registration")
	 (re-search-forward "\\(To: +\\S *\\)" nil t)
	 (progn
	   ;(replace-match (concat "To: " gbm-gbreply-address))
	   (if gbm-gbreply-remove-cc-p
	       (while (re-search-forward "^D?Cc: .*$" nil t)
		 (delete-region
		  (progn (beginning-of-line) (point))
		  (progn (forward-line 1) (point)))))))))

(provide 'gbmedit)

; Local variables: 
; fill-prefix: ";;	" 
; paragraph-start: "^$\\|\\|;;$" 
; paragraph-separate: "^$\\|\\|;;$" 
; End: 
